
   q1 2004.05.16
     - gcc¤¬¥³¥ó¥Ñ¥¤¥ë¤Ç¤­¤Ê¤¤ÅÀ¤ò½¤Àµ
     - C++¥×¥í¥°¥é¥à¤ò¥³¥ó¥Ñ¥¤¥ë¤·¤è¤¦¤È¤¹¤ë¤È¥¨¥é¡¼¤Ë¤Ê¤ëÅÀ¤ò½¤Àµ

diff -Naur gcc-3.4.0.orig/gcc/cppcharset.c gcc-3.4.0/gcc/cppcharset.c
--- gcc-3.4.0.orig/gcc/cppcharset.c	2004-02-03 08:01:55.000000000 +0900
+++ gcc-3.4.0/gcc/cppcharset.c	2004-04-30 23:06:13.000000000 +0900
@@ -275,7 +275,7 @@
    failure, which may be E2BIG (need more space), EILSEQ (ill-formed
    input sequence), ir EINVAL (incomplete input sequence).  */
 
-static inline int
+static int
 one_utf8_to_utf32 (iconv_t bigend, const uchar **inbufp, size_t *inbytesleftp,
 		   uchar **outbufp, size_t *outbytesleftp)
 {
@@ -302,7 +302,7 @@
   return 0;
 }
 
-static inline int
+static int
 one_utf32_to_utf8 (iconv_t bigend, const uchar **inbufp, size_t *inbytesleftp,
 		   uchar **outbufp, size_t *outbytesleftp)
 {
@@ -332,7 +332,7 @@
   return 0;
 }
 
-static inline int
+static int
 one_utf8_to_utf16 (iconv_t bigend, const uchar **inbufp, size_t *inbytesleftp,
 		   uchar **outbufp, size_t *outbytesleftp)
 {
@@ -395,7 +395,7 @@
     }
 }
 
-static inline int
+static int
 one_utf16_to_utf8 (iconv_t bigend, const uchar **inbufp, size_t *inbytesleftp,
 		   uchar **outbufp, size_t *outbytesleftp)
 {
diff -Naur gcc-3.4.0.orig/libjava/interpret.cc gcc-3.4.0/libjava/interpret.cc
--- gcc-3.4.0.orig/libjava/interpret.cc	2003-10-15 02:53:41.000000000 +0900
+++ gcc-3.4.0/libjava/interpret.cc	2004-05-04 21:49:27.000000000 +0900
@@ -95,7 +95,7 @@
 
 // Used to convert from floating types to integral types.
 template<typename TO, typename FROM>
-static inline TO
+static TO
 convert (FROM val, TO min, TO max)
 {
   TO ret;
diff -Naur gcc-3.4.0.orig/libobjc/gc.c gcc-3.4.0/libobjc/gc.c
--- gcc-3.4.0.orig/libobjc/gc.c	2003-05-24 05:04:58.000000000 +0900
+++ gcc-3.4.0/libobjc/gc.c	2004-05-04 20:59:25.000000000 +0900
@@ -26,11 +26,14 @@
    the executable file might be covered by the GNU General Public License.  */
 
 #include "tconfig.h"
+#include "coretypes.h"
+#include "tm.h"
 #include "objc.h"
 #include "encoding.h"
 
 #include <assert.h>
 #include <string.h>
+#include <stdlib.h>
 
 #if OBJC_WITH_GC
 
diff -Naur gcc-3.4.0.orig/libstdc++-v3/include/bits/basic_string.h gcc-3.4.0/libstdc++-v3/include/bits/basic_string.h
--- gcc-3.4.0.orig/libstdc++-v3/include/bits/basic_string.h	2004-03-19 02:36:46.000000000 +0900
+++ gcc-3.4.0/libstdc++-v3/include/bits/basic_string.h	2004-05-16 12:32:59.000000000 +0900
@@ -2032,7 +2032,7 @@
    *  @return  True if @a lhs.compare(@a rhs) == 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator==(const basic_string<_CharT, _Traits, _Alloc>& __lhs,
 	       const basic_string<_CharT, _Traits, _Alloc>& __rhs)
     { return __lhs.compare(__rhs) == 0; }
@@ -2044,7 +2044,7 @@
    *  @return  True if @a rhs.compare(@a lhs) == 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator==(const _CharT* __lhs,
 	       const basic_string<_CharT, _Traits, _Alloc>& __rhs)
     { return __rhs.compare(__lhs) == 0; }
@@ -2056,7 +2056,7 @@
    *  @return  True if @a lhs.compare(@a rhs) == 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator==(const basic_string<_CharT, _Traits, _Alloc>& __lhs,
 	       const _CharT* __rhs)
     { return __lhs.compare(__rhs) == 0; }
@@ -2069,7 +2069,7 @@
    *  @return  True if @a lhs.compare(@a rhs) != 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator!=(const basic_string<_CharT, _Traits, _Alloc>& __lhs,
 	       const basic_string<_CharT, _Traits, _Alloc>& __rhs)
     { return __rhs.compare(__lhs) != 0; }
@@ -2081,7 +2081,7 @@
    *  @return  True if @a rhs.compare(@a lhs) != 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator!=(const _CharT* __lhs,
 	       const basic_string<_CharT, _Traits, _Alloc>& __rhs)
     { return __rhs.compare(__lhs) != 0; }
@@ -2093,7 +2093,7 @@
    *  @return  True if @a lhs.compare(@a rhs) != 0.  False otherwise.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
-    inline bool
+    bool
     operator!=(const basic_string<_CharT, _Traits, _Alloc>& __lhs,
 	       const _CharT* __rhs)
     { return __lhs.compare(__rhs) != 0; }
diff -Naur gcc-3.4.0.orig/libstdc++-v3/include/bits/stl_construct.h gcc-3.4.0/libstdc++-v3/include/bits/stl_construct.h
--- gcc-3.4.0.orig/libstdc++-v3/include/bits/stl_construct.h	2004-03-19 02:36:56.000000000 +0900
+++ gcc-3.4.0/libstdc++-v3/include/bits/stl_construct.h	2004-05-16 12:35:09.000000000 +0900
@@ -73,7 +73,7 @@
    * @endif
    */
   template<typename _T1, typename _T2>
-    inline void
+    void
     _Construct(_T1* __p, const _T2& __value)
     {
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
@@ -88,7 +88,7 @@
    * @endif
    */
   template<typename _T1>
-    inline void
+    void
     _Construct(_T1* __p)
     {
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
@@ -102,7 +102,7 @@
    * @endif
    */
   template<typename _Tp>
-    inline void
+    void
     _Destroy(_Tp* __pointer)
     { __pointer->~_Tp(); }
 
diff -Naur gcc-3.4.0.orig/libstdc++-v3/include/bits/stl_iterator.h gcc-3.4.0/libstdc++-v3/include/bits/stl_iterator.h
--- gcc-3.4.0.orig/libstdc++-v3/include/bits/stl_iterator.h	2004-03-19 02:36:57.000000000 +0900
+++ gcc-3.4.0/libstdc++-v3/include/bits/stl_iterator.h	2004-05-16 12:33:50.000000000 +0900
@@ -273,7 +273,7 @@
    *
   */
   template<typename _Iterator>
-    inline bool
+    bool
     operator==(const reverse_iterator<_Iterator>& __x,
 	       const reverse_iterator<_Iterator>& __y)
     { return __x.base() == __y.base(); }
@@ -285,7 +285,7 @@
     { return __y.base() < __x.base(); }
 
   template<typename _Iterator>
-    inline bool
+    bool
     operator!=(const reverse_iterator<_Iterator>& __x,
 	       const reverse_iterator<_Iterator>& __y)
     { return !(__x == __y); }
@@ -676,25 +676,25 @@
 
   // Forward iterator requirements
   template<typename _IteratorL, typename _IteratorR, typename _Container>
-    inline bool
+    bool
     operator==(const __normal_iterator<_IteratorL, _Container>& __lhs,
 	       const __normal_iterator<_IteratorR, _Container>& __rhs)
     { return __lhs.base() == __rhs.base(); }
 
   template<typename _Iterator, typename _Container>
-    inline bool
+    bool
     operator==(const __normal_iterator<_Iterator, _Container>& __lhs,
 	       const __normal_iterator<_Iterator, _Container>& __rhs)
     { return __lhs.base() == __rhs.base(); }
 
   template<typename _IteratorL, typename _IteratorR, typename _Container>
-    inline bool
+    bool
     operator!=(const __normal_iterator<_IteratorL, _Container>& __lhs,
 	       const __normal_iterator<_IteratorR, _Container>& __rhs)
     { return __lhs.base() != __rhs.base(); }
 
   template<typename _Iterator, typename _Container>
-    inline bool
+    bool
     operator!=(const __normal_iterator<_Iterator, _Container>& __lhs,
 	       const __normal_iterator<_Iterator, _Container>& __rhs)
     { return __lhs.base() != __rhs.base(); }